{"swagger":"2.0","info":{"description":"This is a 3DS SDK Client server API definition.  You\ncan find out more about this at \n[https://w.amazon.com/bin/view/Project_Sentinel/3DSSDK/Architecture/](https://w.amazon.com/bin/view/Project_Sentinel/3DSSDK/Architecture/)\n","version":"1.0.0","title":"3DS SDK Server API's","contact":{"email":"deeprajj@amazon.com"}},"tags":[{"name":"initializeSDK","description":"This call creates session and does device data collection."},{"name":"initiateAuthentication","description":"SDK Client invokes this api to get acs url similar to existing GRU Call."},{"name":"getAuthenticationStatus","description":"SDK Client polls on server to know if Authentication is Frictionless or challenge."},{"name":"generateChallenge","description":"Gets challenge Page to be rendered on client"}],"paths":{"/3dssdk-authentication/initialize-sdk":{"post":{"tags":["initializeSDK"],"description":"SDK Client receives initiate call from Merchant app and starts device data collection and session keys generation and passes it on to SDK Server to store the device data for session id in backend. Depending on SDK Flavour session keys will be generated at client/server.","operationId":"initSdk","consumes":["text/x-amzn-ion"],"produces":["text/x-amzn-ion"],"parameters":[{"in":"body","name":"body","description":"Request to save device data and session keys","required":true,"schema":{"$ref":"#/definitions/InitializeSDKRequest"}}],"responses":{"200":{"description":"success","schema":{"$ref":"#/definitions/InitializeSDKSuccessResponse"}},"default":{"description":"Error","schema":{"$ref":"#/definitions/InitializeSDKErrorResponse"}}}}},"/3dssdk-authentication/{id}/initiate-authentication":{"post":{"tags":["initiateAuthentication"],"summary":"Initiate Authentication process for an Authentication Source","description":"Initiate Authentication process for an Authentication Source","operationId":"initiateAuthentication","consumes":["text/x-amzn-ion"],"produces":["application/x-www-form-urlencoded"],"parameters":[{"name":"id","in":"path","description":"The identifier of the Session created between Client and Server.","required":true,"type":"integer","format":"int64"},{"name":"Prefer","in":"header","description":"Used to indicate that particular server behaviors are preferred by the client\nbut are not required for successful completion of the request. \nFor example, adding the preference token, \"respond-async\" to this header\nwill request the server to perform the operation asynchronously.\n","required":false,"type":"string"},{"in":"body","name":"body","description":"Initiating authentication","required":true,"schema":{"$ref":"#/definitions/InitiateAuthenticationRequest"}}],"responses":{"200":{"description":"successfully Initiated Authentication","schema":{"$ref":"#/definitions/InitiateAuthenticationResponse"}}}}},"/3dssdk-authentication/{id}/getauthenticationstatus":{"get":{"tags":["getAuthenticationStatus"],"summary":"get AS Status if its challenge or frictionless.","operationId":"getASStatus","produces":["text/x-amzn-ion"],"parameters":[{"name":"id","in":"path","description":"The identifier of the Session created between Client and Server.","required":true,"type":"integer","format":"int64"}],"responses":{"200":{"description":"success","schema":{"$ref":"#/definitions/AuthenticationStatus"}},"400":{"description":"Invalid Request."}}}},"/3dssdk-authentication/{id}/generatechallenge":{"post":{"tags":["generateChallenge"],"description":"If the Authentication type is challenge in initiateAuthentication response then SDK Client invokes this api to render challenge screen.","operationId":"getOrderById","consumes":["text/x-amzn-ion"],"produces":["text/x-amzn-ion"],"parameters":[{"name":"id","in":"path","description":"The identifier of the Session created between Client and Server.","required":true,"type":"integer","format":"int64"},{"in":"body","name":"body","description":"order placed for purchasing the pet","required":true,"schema":{"$ref":"#/definitions/ChallengeRequest"}}],"responses":{"200":{"description":"success","schema":{"$ref":"#/definitions/ChallengeResponse"}},"400":{"description":"Invalid Request"}}}}},"definitions":{"InitializeSDKRequest":{"type":"object","description":"The Initialize SDK request is fired by client to encrypt and store device data against session ID","properties":{"session_key":{"type":"object","description":"The public key component of the ephemeral key pair generated by the 3DS SDK and used to establish session keys between the 3DS SDK and ACS.","properties":{"kty":{"type":"string","example":"EC"},"crv":{"type":"string","example":"P-256"},"X":{"type":"string","example":"_NohgCJdJMwqAJLf0KvBibZk-kiiBLfVr1aFjq_MXsg"},"Y":{"type":"string","example":"xVWNBHhJpaMb8G6FMwSiD7CyxGji6GYMSyW1A380wuM"}}},"three_ds_sdk_app_id":{"type":"string","description":"Universally Unique ID created upon all installations and updates of the 3DS Requestor App on a Consumer Device. This will be newly generated and stored by the 3DS SDK for each installation or update.","example":"6d9f1f0f-b15c-4200-a2d8-953181edfc6e"},"three_ds_sdk_reference_number":{"type":"string","description":"Identifies the vendor and version for the 3DS SDK that is integrated into a 3DS Requestor App, assigned by EMVCo when the 3DS SDK is approved.","example":"3DS_LOA_SDK_ADBV_739485_94783"},"deviceInfo":{"type":"object","description":"The device data collected at client side as per EMVCo mandatory common and platform specific fields.","properties":{"Platform":{"type":"string","example":"Android"},"DeviceModel":{"type":"string","example":"HTC One_M8"},"OSName":{"type":"string","example":"Android"},"OSVersion":{"type":"string","example":"5.0.1"},"Locale":{"type":"string","example":"en_US"},"TimeZone":{"type":"string","example":"Eastern Standard Time"},"AdvID":{"type":"string","example":"06797903-fb61-41ed-94c2-4d2b74e27d18"},"ScreenResolution":{"type":"string"},"DeviceName":{"type":"string"},"IPAddress":{"type":"string"},"Latitude":{"type":"string"},"Longitude":{"type":"string"},"AppPackageName":{"type":"string"},"SDKAppID":{"type":"string"},"SDKVersion":{"type":"string"},"DeviceId":{"type":"string"},"DeviceType":{"type":"string","example":{"01":"Desktop","02":"TV connected","03":"Tablet/Mobile","04":"Headless/Voice","05":"Wearable","06":"IOT","99":"Other"}},"InputType":{"type":"string","example":{"01":"Physical Keyboard","02":"Touch Keyboard","03":"TV connected Onscreen Keyboard","04":"Voice Activated","05":"Gesture Activated","99":"Other"}},"OutputType":{"type":"string","example":{"01":"Display","02":"Audio","03":"Monochrome Display","99":"Other"}},"LogoPreferenceColour":{"type":"string","example":{"01":"Full Colour","02":"Monochrome White","03":"Monochrome Black","99":"Other"}},"UserID":{"type":"string"},"Languages":{"type":"string"},"OriginatingDeviceID":{"type":"string"}}}}},"InitializeSDKSuccessResponse":{"type":"object","description":"The success message for InitializeSDK API Call. SDK Server will send back the session_id to client for future requests.","properties":{"session_id":{"type":"string","example":"amz1.sdkserver.sessions.OWNkMTZhYWUtMDUwOC0zYjQzLTg4YWYtODliZDA0NWEzN2U4"}}},"InitializeSDKErrorResponse":{"type":"object","description":"The error message for InitializeSDK.","properties":{"Reason":{"type":"string","enum":["Missing fields in request","Missing Arguments in DeviceInfo","Generic error"]}}},"InitiateAuthenticationRequest":{"type":"object","properties":{"session_id":{"type":"string","example":"b08d1690b26e-8a880dc0-d2d2-4067-bcb1"},"payment_method":{"type":"object","properties":{"category":{"type":"string","example":"Card"},"id":{"type":"string","example":"amzn1.pm.wallet.MGhfUFVfQ1VTXzY3NTFlOWQ2LTg2NGQtNGQxNy1iNGY1LTYzNmEyZGYzN2I4MA.QTJCOUgyTzBWTEpQQ1k"},"issuingBank":{"type":"string","example":"Santander UK PLC"},"countryCode":{"type":"string","example":"GBR"},"basicCreditCardIssuer":{"type":"string","example":"Visa"},"selected_financial_offer":{"type":"object","properties":{"id":{"type":"string","example":"amzn1.fos.c6f24462-02b3-47fc-ae8d-98b494697b32"},"category":{"type":"string","example":"Installment"}}}}}}},"InitiateAuthenticationResponse":{"type":"object","properties":{"three_ds_server_transaction_id":{"type":"string","example":"8a880dc0-d2d2-4067-bcb1-b08d1690b26e"},"dsReferenceNumber":{"type":"string","example":"DS_LOA_DIS_PPFU_020100_00010"},"dsTransID":{"type":"string","example":"f25084f0-5b16-4c0a-ae5d-b24808a95e4b"},"messageVersion":{"type":"string","example":"2.1.0"},"sdkTransID":{"type":"string","example":"b2385523-a66c-4907-ac3c-91848e8c0067"},"messageType":{"type":"string","example":"ARes"},"transStatus":{"type":"string","example":"Y"},"acsOperatorID":{"type":"string","example":"AcsOpId 4138359541"}}},"AuthenticationStatus":{"type":"object","properties":{"ChallengeRequired":{"type":"string","example":"N","description":"Client will use this field as an indicator for authentication status"},"ChallengeCompletionIndicator":{"type":"string","example":"N","description":"Client will use this field as an indicator for challenge completion status"}}},"ChallengeRequest":{"type":"object","properties":{"challengeRequestData":{"type":"Object","properties":{"three_ds_server_transaction_id":{"type":"string","example":"8a880dc0-d2d2-4067-bcb1-b08d1690b26e"},"acs_transaction_id":{"type":"string","example":"d7c1ee99-9478-44a6-b1f2-391e29c6b340"},"messageType":{"type":"string","example":"CReq"},"messageVersion":{"type":"string","example":"2.1.0"},"sdkTransID":{"type":"string","example":"b2385523-a66c-4907-ac3c-91848e8c0067"}}},"decryption_key":{"type":"string","example":"bWUC9B-EFRIo8kpGfh0ZuyGPvMNKvYWNtB_ikiH9k20eTO1q_I78eiZkpXxXQ0UTEs2LsNRS-8uJbvQA1irkwMSMkK1J3XTGgdrhCku9gRldY7sNA_AKZGh-Q661_42rINLRCe8WnZ34ui_qOfkLnK9QWDDqpaIsAbMwWWSDFu2MUBYwkHTMEzLYGqOe04noqeq1hExBTHBOBdkMXiuFhUq1BU6lDqEiWxqg82sXt2hLMnT3046AOYJoRioz75tSUQfGCshWTBnP5uDjd18kKhyv07lhfSJdrPdM5Plyl21hsFf"}},"xml":{"name":"ChallengeRequest"}},"ChallengeResponse":{"type":"object","properties":{"acsUiType":{"type":"string","example":"01"},"challengeAddInfo":{"type":"string"},"challengeCompletionInd":{"type":"string"},"challengeInfoHeader":{"type":"string","example":"Header information"},"challengeInfoLabel":{"type":"string","example":"One-time-password"},"challengeInfoText":{"type":"string","example":"Please enter the received one-time-password"},"challengeInfoTextIndicator":{"type":"string","example":"N"},"expandInfoLabel":{"type":"string","example":"Additional instructions"},"expandInfoText":{"type":"string","example":"The issuer will send you via SMS..."},"issuerImage":{"type":"object","additionalProperties":{"type":"string"},"example":{"medium":"https://acs.com/medium_image.svg","high":"https://acs.com/high_image.svg","extraHigh":"https://acs.com/extraHigh_image.svg"}},"messageType":{"type":"string","example":"CRES"},"messageVersion":{"type":"string","example":"2.1.0"},"psImage":{"type":"object","additionalProperties":{"type":"string"},"example":{"medium":"https://ds.com/medium_image.svg","high":"https://ds.com/high_image.svg","extraHigh":"https://ds.com/extraHigh_image.svg"}},"whyInfoLabel":{"type":"string","example":"Why using 3-D Secure?"},"whyInfoText":{"type":"string","example":"Some explanation about why using 3-D Secure"}},"xml":{"name":"ChallengeResponse"}}},"externalDocs":{"description":"Find out more about Swagger","url":"http://swagger.io"},"host":"virtserver.swaggerhub.com","schemes":["https","http"],"basePath":"/deeprajjha1/3ds-sdk/1.0.0"}